#include "PKIBBox.h"

#define DLL_ROUTINE_COUNT	191

#define DLL_NAME	TEXT("pkibbox.dll")

static HMODULE	hDll = NULL;
static LONG nDllRefs = 0;

static FARPROC	aDllRoutines[DLL_ROUTINE_COUNT] = {
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL,	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 
	NULL
};

static LPTSTR	aDllRoutineNames[DLL_ROUTINE_COUNT] = {
    TEXT("SBX509GetVersion"),
    TEXT("SBX509GetSerialNumber"),
    TEXT("SBX509Create"),
    TEXT("SBX509LoadFromBuffer"),
    TEXT("SBX509GetCertificateBinary"),
    TEXT("SBX509GetSignature"),
    TEXT("SBX509GetIssuer"),
    TEXT("SBX509GetValidFrom"),
    TEXT("SBX509GetValidTo"),
    TEXT("SBX509GetSubject"),
    TEXT("SBX509GetSignatureAlgorithm"),
    TEXT("SBX509GetPublicKeyAlgorithm"),
    TEXT("SBX509GetRSAParams"),
    TEXT("SBX509GetDSSSignatureParams"),
    TEXT("SBX509GetDSSParams"),
    TEXT("SBX509GetDHParams"),
    TEXT("SBX509SelfSigned"),
    TEXT("SBX509Validate"),
    TEXT("SBX509ValidateRSA"),
    TEXT("SBX509ValidateDSS"),
    TEXT("SBX509ValidateWithCA"),
    TEXT("SBX509SetIssuer"),
    TEXT("SBX509SetSubject"),
    TEXT("SBX509SaveToBuffer"),
    TEXT("SBX509SaveKeyToBuffer"),
    TEXT("SBX509Generate"),
    TEXT("SBX509CAGenerate"),
    TEXT("SBX509SetCACertificate"),
    TEXT("SBX509SetCAPrivateKey"),
    TEXT("SBX509Destroy"),
    TEXT("SBX509SetValidFrom"),
    TEXT("SBX509SetValidTo"),
    TEXT("SBX509LoadKeyFromBuffer"),
    TEXT("SBX509LoadFromBufferPEM"),
    TEXT("SBX509LoadKeyFromBufferPEM"),
    TEXT("SBX509SaveToBufferPEM"),
    TEXT("SBX509SaveKeyToBufferPEM"),
    TEXT("SBX509Clone"),
    TEXT("SBX509GetHashMD5"),
    TEXT("SBX509GetHashSHA1"),
    TEXT("SBX509GetPublicKeySize"),
    TEXT("SBX509GetPublicKeyBlob"),
    TEXT("SBX509PrivateKeyExists"),
    TEXT("SBX509LoadFromBufferPFX"),
    TEXT("SBX509SaveToBufferPFX"),
    TEXT("SBX509Sign"),
    TEXT("SBX509Verify"),
    TEXT("SBX509GenerateByRequest"),
    TEXT("SBX509GetIssuerRDN"),
    TEXT("SBX509GetSubjectRDN"),
    TEXT("SBX509SignDetached"),
    TEXT("SBGetAvailableSystemStores"),
    TEXT("SBGetAvailablePhysicalStores"),
    TEXT("SBCertStorageFindByHashMD5"),
    TEXT("SBCertStorageFindByHashSHA1"),
    TEXT("SBCertStorageGetIssuerCertificate"),
    TEXT("SBWinCertStorageCreate"),
    TEXT("SBWinCertStorageDestroy"),
    TEXT("SBWinCertStorageValidate"),
    TEXT("SBWinCertStorageAdd"),
    TEXT("SBWinCertStorageRemove"),
    TEXT("SBWinCertStorageRemoveAll"),
    TEXT("SBWinCertStorageAddCertificate"),
    TEXT("SBWinCertStorageAddCertificateTo"),
    TEXT("SBWinCertStorageRemoveCertificate"),
    TEXT("SBWinCertStorageGetCertificate"),
    TEXT("SBWinCertStorageGetCount"),
    TEXT("SBWinCertStorageExportTo"),
    TEXT("SBFileCertStorageCreate"),
    TEXT("SBFileCertStorageDestroy"),
    TEXT("SBFileCertStorageValidate"),
    TEXT("SBFileCertStorageSetFilename"),
    TEXT("SBFileCertStorageAdd"),
    TEXT("SBFileCertStorageRemove"),
    TEXT("SBFileCertStorageGetCertificate"),
    TEXT("SBFileCertStorageGetCount"),
    TEXT("SBFileCertStorageSaveToFile"),
    TEXT("SBFileCertStorageExportTo"),
    TEXT("SBMemoryCertStorageCreate"),
    TEXT("SBMemoryCertStorageDestroy"),
    TEXT("SBMemoryCertStorageValidate"),
    TEXT("SBMemoryCertStorageAdd"),
    TEXT("SBMemoryCertStorageRemove"),
    TEXT("SBMemoryCertStorageGetCertificate"),
    TEXT("SBMemoryCertStorageGetCount"),
    TEXT("SBMemoryCertStorageExportTo"),
    TEXT("SBRelativeDistinguishedNameCreate"),
    TEXT("SBRelativeDistinguishedNameDestroy"),
    TEXT("SBRelativeDistinguishedNameSetCount"),
    TEXT("SBRelativeDistinguishedNameGetCount"),
    TEXT("SBRelativeDistinguishedNameSetOID"),
    TEXT("SBRelativeDistinguishedNameGetOID"),
    TEXT("SBRelativeDistinguishedNameSetValue"),
    TEXT("SBRelativeDistinguishedNameGetValue"),
    TEXT("SBRelativeDistinguishedNameRemove"),
    TEXT("SBCertificateRequestCreate"),
    TEXT("SBCertificateRequestDestroy"),
    TEXT("SBCertificateRequestLoadFromBuffer"),
    TEXT("SBCertificateRequestGenerate"),
    TEXT("SBCertificateRequestSaveToBuffer"),
    TEXT("SBCertificateRequestValidateSignature"),
    TEXT("SBCertificateRequestGetRSAParams"),
    TEXT("SBCertificateRequestGetDSAParams"),
    TEXT("SBCertificateRequestGetPrivateKey"),
    TEXT("SBCertificateRequestGetSubject"),
    TEXT("SBCertificateRequestGetAttributes"),
    TEXT("SBCertificateRequestGetPublicKeyAlgorithm"),
    TEXT("SBCertificateRequestGetSignatureAlgorithm"),
    TEXT("SBMessageEncryptorCreate"),
    TEXT("SBMessageEncryptorDestroy"),
    TEXT("SBMessageEncryptorSetCertStorage"),
    TEXT("SBMessageEncryptorGetCertStorage"),
    TEXT("SBMessageEncryptorSetAlgorithm"),
    TEXT("SBMessageEncryptorGetAlgorithm"),
    TEXT("SBMessageEncryptorSetBitsInKey"),
    TEXT("SBMessageEncryptorGetBitsInKey"),
    TEXT("SBMessageEncryptorEncrypt"),
    TEXT("SBMessageDecryptorCreate"),
    TEXT("SBMessageDecryptorDestroy"),
    TEXT("SBMessageDecryptorSetCertStorage"),
    TEXT("SBMessageDecryptorGetCertStorage"),
    TEXT("SBMessageDecryptorGetAlgorithm"),
    TEXT("SBMessageDecryptorGetBitsInKey"),
    TEXT("SBMessageDecryptorDecrypt"),
    TEXT("SBMessageDecryptorGetUsedCertificate"),
    TEXT("SBMessageDecryptorGetCertID"),
    TEXT("SBMessageDecryptorGetCertIDCount"),
    TEXT("SBMessageSignerCreate"),
    TEXT("SBMessageSignerDestroy"),
    TEXT("SBMessageSignerSetHashAlgorithm"),
    TEXT("SBMessageSignerGetHashAlgorithm"),
    TEXT("SBMessageSignerSetCertStorage"),
    TEXT("SBMessageSignerGetCertStorage"),
    TEXT("SBMessageSignerSign"),
    TEXT("SBMessageSignerSignDetached"),
    TEXT("SBMessageSignerGetAuthenticatedAttributes"),
    TEXT("SBMessageSignerGetUnauthenticatedAttributes"),
    TEXT("SBMessageVerifierCreate"),
    TEXT("SBMessageVerifierDestroy"),
    TEXT("SBMessageVerifierSetCertStorage"),
    TEXT("SBMessageVerifierGetCertStorage"),
    TEXT("SBMessageVerifierGetHashAlgorithm"),
    TEXT("SBMessageVerifierGetCertificates"),
    TEXT("SBMessageVerifierVerify"),
    TEXT("SBMessageVerifierVerifyDetached"),
    TEXT("SBMessageVerifierIsSignatureDetached"),
    TEXT("SBMessageVerifierGetCertID"),
    TEXT("SBMessageVerifierGetCertIDCount"),
    TEXT("SBMessageVerifierGetAttributes"),
    TEXT("SBRandomCreate"),
    TEXT("SBRandomDestroy"),
    TEXT("SBRandomRandomize"),
    TEXT("SBRandomGenerate"),
    TEXT("SBPKCS7IssuerGetIssuer"),
    TEXT("SBPKCS7IssuerGetSerialNumber"),
    TEXT("SBPKCS7IssuerSetSerialNumber"),
    TEXT("SBArrayListGetCount"),
    TEXT("SBArrayListGetValue"),
    TEXT("SBArrayListSetValue"),
    TEXT("SBArrayListAdd"),
    TEXT("SBArrayListRemove"),
    TEXT("SBPKCS7AttributesRemove"),
    TEXT("SBPKCS7AttributesGetAttribute"),
    TEXT("SBPKCS7AttributesSetAttribute"),
    TEXT("SBPKCS7AttributesGetValues"),
    TEXT("SBPKCS7AttributesGetCount"),
    TEXT("SBPKCS7AttributesSetCount"),
    TEXT("SBFormatAttributeValue"),
    TEXT("SBUnformatAttributeValue"),
    TEXT("SBCertificateRevocationListCreate"),
    TEXT("SBCertificateRevocationListDestroy"),
    TEXT("SBCertificateRevocationListAdd"),
    TEXT("SBCertificateRevocationListRemoveByIndex"),
    TEXT("SBCertificateRevocationListRemove"),
    TEXT("SBCertificateRevocationListIsPresent"),
    TEXT("SBCertificateRevocationListLoadFromBuffer"),
    TEXT("SBCertificateRevocationListSaveToBuffer"),
    TEXT("SBCertificateRevocationListValidate"),
    TEXT("SBCertificateRevocationListGetIssuer"),
    TEXT("SBCertificateRevocationListGetThisUpdate"),
    TEXT("SBCertificateRevocationListGetNextUpdate"),
    TEXT("SBCertificateRevocationListSetThisUpdate"),
    TEXT("SBCertificateRevocationListSetNextUpdate"),
    TEXT("SBCertificateRevocationListGetSignatureAlgorithm"),
    TEXT("SBCertificateRevocationListGetItem"),
    TEXT("SBCertificateRevocationListGetCount"),
    TEXT("SBRevocationItemGetSerialNumber"),
    TEXT("SBRevocationItemSetSerialNumber"),
    TEXT("SBRevocationItemGetRevocationDate"),
    TEXT("SBRevocationItemSetRevocationDate"),
	TEXT("SetLicenseKey")
};


typedef HANDLE (__stdcall *SBX509CreateProc)(void);
typedef int (__stdcall *SBX509GetVersionProc)(HANDLE hCert);
typedef BOOL (__stdcall *SBX509GetSerialNumberProc)(HANDLE hCert, void* pSerialNumber, int* Size);
typedef BOOL (__stdcall *SBX509LoadFromBufferProc)(HANDLE hCert, void* pData, int Size);
typedef BOOL (__stdcall *SBX509GetCertificateBinaryProc)(HANDLE hCert, void* pBinaryData, int* Size);
typedef BOOL (__stdcall *SBX509GetSignatureValueProc)(HANDLE hCert, void* pSignature, int* Size);
typedef BOOL (__stdcall *SBX509GetIssuerProc)(HANDLE hCert, void* pIssuer, int* Size);
typedef BOOL (__stdcall *SBX509GetSubjectProc)(HANDLE hCert, void* pSubject, int* Size);
typedef BOOL (__stdcall *SBX509GetValidityFromProc)(HANDLE hCert, DATE* Date);
typedef BOOL (__stdcall *SBX509GetValidityToProc)(HANDLE hCert, DATE* Date);
typedef int (__stdcall *SBX509GetSignatureAlgorithmProc)(HANDLE hCert);
typedef int (__stdcall *SBX509GetPublicKeyAlgorithmProc)(HANDLE hCert);
typedef BOOL (__stdcall *SBX509GetRSAParamsProc)(HANDLE hCert, void* pRSAModulus, int* nRSAModulusSize,
				void* pRSAPublicExponent, int* nRSAPublicExponentSize);
typedef BOOL (__stdcall *SBX509GetDSSSignatureParamsProc)(HANDLE hCert, void* pDSSS, int* nDSSSSize,
				void* pDSSR, int* nDSSRSize);
typedef BOOL (__stdcall *SBX509GetDSSParamsProc)(HANDLE hCert, void* pDSSP, int* nDSSPSize,
				void* pDSSQ, int* nDSSQSize, void* pDSSG, int* nDSSGSize, void* pDSSY, int* nDSSYSize);
typedef BOOL (__stdcall *SBX509GetDHParamsProc)(HANDLE hCert, void* pDHP, int* nDHPSize, 
				void* pDHG, int* nDHGSize, void* pDHY, int* nDHYSize);
typedef BOOL (__stdcall *SBX509IsCertificateSelfSignedProc)(HANDLE hCert);
typedef BOOL (__stdcall *SBX509ValidateProc)(HANDLE hCert);
typedef BOOL (__stdcall *SBX509ValidateRSAProc)(HANDLE hCert, void* pRSAModulus, int nRSAModulusSize,
				void* pRSAPublicExponent, int nRSAPublicExponentSize);
typedef BOOL (__stdcall *SBX509ValidateDSSProc)(HANDLE hCert, void* pDSSP, int nDSSPSize, 
				void* pDSSQ, int nDSSQSize, void* pDSSG, int nDSSGSize, void* pDSSY,
				int nDSSYSize);
typedef BOOL (__stdcall *SBX509ValidateWithCAProc)(HANDLE hCert, void* pCACertificate, int nCACertificateSize);
typedef BOOL (__stdcall *SBX509SetIssuerProc)(HANDLE hCert, PCHAR Fields[]);
typedef BOOL (__stdcall *SBX509SetSubjectProc)(HANDLE hCert, PCHAR Fields[]);
typedef BOOL (__stdcall *SBX509SaveToBufferProc)(HANDLE hCert, void* Buffer, int* nSize);
typedef BOOL (__stdcall *SBX509SaveKeyToBufferProc)(HANDLE hCert, void* Buffer, int* nSize);
typedef BOOL (__stdcall *SBX509GenerateProc)(HANDLE hCert, int nAlgorithm, int nDwordsInEncryptKey);
typedef BOOL (__stdcall *SBX509CAGenerateProc)(HANDLE hCert, int nAlgorithm, int nDwordsInEncryptKey);
typedef BOOL (__stdcall *SBX509SetCACertificateProc)(HANDLE hCert, void* Buffer, int nSize);
typedef BOOL (__stdcall *SBX509SetCAPrivateKeyProc)(HANDLE hCert, void* Buffer, int nSize);
typedef BOOL (__stdcall *SBX509DestroyProc)(HANDLE hCert);
typedef BOOL (__stdcall *SBX509SetValidityFromProc)(HANDLE hCert, DATE Date);
typedef BOOL (__stdcall *SBX509SetValidityToProc)(HANDLE hCert, DATE Date);
typedef BOOL (__stdcall *SBX509LoadKeyFromBufferProc)(HANDLE hCert, void* Buffer, int nSize);
typedef BOOL (__stdcall *SBX509LoadFromBufferPEMProc)(HANDLE hCert, void* Buffer, int nSize, PCHAR PassPhrase);
typedef BOOL (__stdcall *SBX509LoadKeyFromBufferPEMProc)(HANDLE hCert, void* Buffer, int nSize, PCHAR PassPhrase);
typedef BOOL (__stdcall *SBX509SaveToBufferPEMProc)(HANDLE hCert, void* Buffer, int* nSize, PCHAR PassPhrase);
typedef BOOL (__stdcall *SBX509SaveKeyToBufferPEMProc)(HANDLE hCert, void* Buffer, int* nSize, PCHAR PassPhrase);
typedef BOOL (__stdcall *SBX509CloneProc)(HANDLE hCert, HANDLE hDestCert);
typedef BOOL (__stdcall *SBX509GetHashMD5Proc)(HANDLE hCert, void* pBuffer);
typedef BOOL (__stdcall *SBX509GetHashSHA1Proc)(HANDLE hCert, void* pBuffer);
typedef int (__stdcall *SBX509GetPublicKeySizeProc)(HANDLE hCert);
typedef BOOL (__stdcall *SBX509GetPublicKeyBlobProc)(HANDLE hCert, void* pBuffer, int* nSize);
typedef BOOL (__stdcall *SBX509PrivateKeyExistsProc)(HANDLE hCert);
typedef BOOL (__stdcall *SBGetAvailableSystemStoresProc)(char** pBuffer, int* nSize);
typedef BOOL (__stdcall *SBGetAvailablePhysicalStoresProc)(char* szSystemStore, char** pBuffer, int* nSize);
typedef int (__stdcall *SBCertStorageFindByHashMD5Proc)(HANDLE hStorage, void* pHash);
typedef int (__stdcall *SBCertStorageFindByHashSHA1Proc)(HANDLE hStorage, void* pHash);
typedef int (__stdcall *SBCertStorageGetIssuerCertificateProc)(HANDLE hStorage, HANDLE hCert);

typedef HANDLE (__stdcall *SBWinCertStorageCreateProc)(void);
typedef BOOL (__stdcall *SBWinCertStorageDestroyProc)(HANDLE hStorage);
typedef int (__stdcall *SBWinCertStorageValidateProc)(HANDLE hStorage, HANDLE hCert,
  int* nReason);
typedef BOOL (__stdcall *SBWinCertStorageAddProc)(HANDLE hStorage, PCHAR StoreName);
typedef BOOL (__stdcall *SBWinCertStorageRemoveProc)(HANDLE hStorage, PCHAR StoreName);
typedef BOOL (__stdcall *SBWinCertStorageRemoveAllProc)(HANDLE hStorage);
typedef BOOL (__stdcall *SBWinCertStorageAddCertificateProc)(HANDLE hStorage, HANDLE hCert);
typedef BOOL (__stdcall *SBWinCertStorageAddCertificateToProc)(HANDLE hStorage, HANDLE hCert, PCHAR StoreName);
typedef BOOL (__stdcall *SBWinCertStorageRemoveCertificateProc)(HANDLE hStorage, int nIndex);
typedef HANDLE (__stdcall *SBWinCertStorageGetCertificateProc)(HANDLE hStorage, int nIndex);
typedef int (__stdcall *SBWinCertStorageGetCountProc)(HANDLE hStorage);
typedef BOOL (__stdcall *SBWinCertStorageExportToProc)(HANDLE hStorage, HANDLE hExportToStorage);
typedef HANDLE (__stdcall *SBFileCertStorageCreateProc)(void);
typedef BOOL (__stdcall *SBFileCertStorageDestroyProc)(HANDLE hStorage);
typedef int	(__stdcall *SBFileCertStorageValidateProc)(HANDLE hStorage, HANDLE hCert, 
  int* Reason);
typedef BOOL (__stdcall *SBFileCertStorageSetFilenameProc)(HANDLE hStorage, PCHAR Filename); 
typedef BOOL (__stdcall *SBFileCertStorageAddProc)(HANDLE hStorage, HANDLE hCert);
typedef BOOL (__stdcall *SBFileCertStorageRemoveProc)(HANDLE hStorage, int nIndex);
typedef HANDLE (__stdcall *SBFileCertStorageGetCertificateProc)(HANDLE hStorage, int nIndex);
typedef int (__stdcall *SBFileCertStorageGetCountProc)(HANDLE hStorage);
typedef BOOL (__stdcall *SBFileCertStorageSaveToFileProc)(HANDLE hStorage, PCHAR Filename);
typedef BOOL (__stdcall *SBFileCertStorageExportToProc)(HANDLE hStorage, HANDLE hExportToStorage);
typedef HANDLE (__stdcall *SBMemoryCertStorageCreateProc)(void);
typedef BOOL (__stdcall *SBMemoryCertStorageDestroyProc)(HANDLE hStorage);
typedef int (__stdcall *SBMemoryCertStorageValidateProc)(HANDLE hStorage, HANDLE hCert, int* Reason);
typedef BOOL (__stdcall *SBMemoryCertStorageAddProc)(HANDLE hStorage, HANDLE hCert);
typedef BOOL (__stdcall *SBMemoryCertStorageRemoveProc)(HANDLE hStorage, int nIndex);
typedef HANDLE (__stdcall *SBMemoryCertStorageGetCertificateProc)(HANDLE hStorage, int nIndex);
typedef int (__stdcall *SBMemoryCertStorageGetCountProc)(HANDLE hStorage);
typedef BOOL (__stdcall *SBMemoryCertStorageExportToProc)(HANDLE hStorage, HANDLE hExportToStorage);
typedef int (__stdcall *SBX509LoadFromBufferPFXProc)(HANDLE hCert, void* pBuffer, int nSize, PCHAR Password);
typedef int (__stdcall *SBX509SaveToBufferPFXProc)(HANDLE hCert, void* pBuffer, int* nSize, PCHAR Password, int KeyEncryptionAlgorithm, int CertEncryptionAlgorithm);
typedef int (__stdcall *SBX509SignProc)(HANDLE hCert, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize);
typedef int (__stdcall *SBX509VerifyProc)(HANDLE hCert, void* pInBuffer, int nInSize, void* pSignature, int nSignatureSize);
typedef BOOL (__stdcall *SBX509GenerateByRequestProc)(HANDLE hCert, HANDLE hRequest, HANDLE hNewCert);
typedef HANDLE (__stdcall *SBRelativeDistinguishedNameCreateProc)(void);
typedef BOOL (__stdcall *SBRelativeDistinguishedNameDestroyProc)(HANDLE hName);
typedef BOOL (__stdcall *SBRelativeDistinguishedNameSetCountProc)(HANDLE hName, int Count);
typedef int (__stdcall *SBRelativeDistinguishedNameGetCountProc)(HANDLE hName);
typedef BOOL (__stdcall *SBRelativeDistinguishedNameSetOIDProc)(HANDLE hName, int Index, void* pBuffer, int nSize);
typedef BOOL (__stdcall *SBRelativeDistinguishedNameGetOIDProc)(HANDLE hName, int Index, void* pBuffer, int* nSize);
typedef BOOL (__stdcall *SBRelativeDistinguishedNameSetValueProc)(HANDLE hName, int Index, void* pBuffer, int nSize);
typedef BOOL (__stdcall *SBRelativeDistinguishedNameGetValueProc)(HANDLE hName, int Index, void* pBuffer, int* nSize);
typedef BOOL (__stdcall *SBRelativeDistinguishedNameRemoveProc)(HANDLE hName, int Index);
typedef HANDLE (__stdcall *SBCertificateRequestCreateProc)(void);
typedef BOOL (__stdcall *SBCertificateRequestDestroyProc)(HANDLE hRequest);
typedef BOOL (__stdcall *SBCertificateRequestLoadFromBufferProc)(HANDLE hRequest, void* pBuffer, int nSize);
typedef BOOL (__stdcall *SBCertificateRequestGenerateProc)(HANDLE hRequest, int PublicKeyAlgorithm, int Bits, int SignatureAlgorithm);
typedef BOOL (__stdcall *SBCertificateRequestSaveToBufferProc)(HANDLE hRequest, void* pBuffer, int* nSize);
typedef BOOL (__stdcall *SBCertificateRequestValidateSignatureProc)(HANDLE hRequest);
typedef BOOL (__stdcall *SBCertificateRequestGetRSAParamsProc)(HANDLE hRequest, void* pPublicModulus, int* nPublicModulusSize, void* pPublicExponent, int* nPublicExponentSize);
typedef BOOL (__stdcall *SBCertificateRequestGetDSAParamsProc)(HANDLE hRequest, void* pP, int* nPSize, void* pQ, int* nQSize, void* pG, int* nGSize, void* pY, int* nYSize);
typedef BOOL (__stdcall *SBCertificateRequestGetPrivateKeyProc)(HANDLE hRequest, void* pBuffer, int* nSize);
typedef HANDLE (__stdcall *SBCertificateRequestGetSubjectProc)(HANDLE hRequest);
typedef HANDLE (__stdcall *SBCertificateRequestGetAttributesProc)(HANDLE hRequest);
typedef int (__stdcall *SBCertificateRequestGetPublicKeyAlgorithmProc)(HANDLE hRequest);
typedef int (__stdcall *SBCertificateRequestGetSignatureAlgorithmProc)(HANDLE hRequest);
typedef HANDLE (__stdcall *SBMessageEncryptorCreateProc)(void);
typedef BOOL (__stdcall *SBMessageEncryptorDestroyProc)(HANDLE hEncryptor);
typedef BOOL (__stdcall *SBMessageEncryptorSetCertStorageProc)(HANDLE hEncryptor, HANDLE hStorage);
typedef HANDLE (__stdcall *SBMessageEncryptorGetCertStorageProc)(HANDLE hEncryptor);
typedef BOOL (__stdcall *SBMessageEncryptorSetAlgorithmProc)(HANDLE hEncryptor, int Algorithm);
typedef int (__stdcall *SBMessageEncryptorGetAlgorithmProc)(HANDLE hEncryptor);
typedef BOOL (__stdcall *SBMessageEncryptorSetBitsInKeyProc)(HANDLE hEncryptor, int Bits);
typedef int (__stdcall *SBMessageEncryptorGetBitsInKeyProc)(HANDLE hEncryptor);
typedef int (__stdcall *SBMessageEncryptorEncryptProc)(HANDLE hEncryptor, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize);
typedef HANDLE (__stdcall *SBMessageDecryptorCreateProc)(void);
typedef BOOL (__stdcall *SBMessageDecryptorDestroyProc)(HANDLE hDecryptor);
typedef BOOL (__stdcall *SBMessageDecryptorSetCertStorageProc)(HANDLE hDecryptor, HANDLE hStorage);
typedef HANDLE (__stdcall *SBMessageDecryptorGetCertStorageProc)(HANDLE hDecryptor);
typedef int (__stdcall *SBMessageDecryptorGetAlgorithmProc)(HANDLE hDecryptor);
typedef int (__stdcall *SBMessageDecryptorGetBitsInKeyProc)(HANDLE hDecryptor);
typedef int (__stdcall *SBMessageDecryptorDecryptProc)(HANDLE hDecryptor, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize);
typedef HANDLE (__stdcall *SBMessageSignerCreateProc)(void);
typedef BOOL (__stdcall *SBMessageSignerDestroyProc)(HANDLE hSigner);
typedef BOOL (__stdcall *SBMessageSignerSetHashAlgorithmProc)(HANDLE hSigner, int Algorithm);
typedef int (__stdcall *SBMessageSignerGetHashAlgorithmProc)(HANDLE hSigner);
typedef BOOL (__stdcall *SBMessageSignerSetCertStorageProc)(HANDLE hSigner, HANDLE hStorage);
typedef HANDLE (__stdcall *SBMessageSignerGetCertStorageProc)(HANDLE hSigner);
typedef int (__stdcall *SBMessageSignerSignProc)(HANDLE hSigner, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize);
typedef HANDLE (__stdcall *SBMessageVerifierCreateProc)(void);
typedef BOOL (__stdcall *SBMessageVerifierDestroyProc)(HANDLE hVerifier);
typedef BOOL (__stdcall *SBMessageVerifierSetCertStorageProc)(HANDLE hVerifier, HANDLE hStorage);
typedef HANDLE (__stdcall *SBMessageVerifierGetCertStorageProc)(HANDLE hVerifier);
typedef int (__stdcall *SBMessageVerifierGetHashAlgorithmProc)(HANDLE hVerifier);
typedef HANDLE (__stdcall *SBMessageVerifierGetCertificatesProc)(HANDLE hVerifier);
typedef int (__stdcall *SBMessageVerifierVerifyProc)(HANDLE hVerifier, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize);
typedef HANDLE (__stdcall *SBRandomCreateProc)(void);
typedef BOOL (__stdcall *SBRandomDestroyProc)(HANDLE hRandom);
typedef BOOL (__stdcall *SBRandomRandomizeProc)(HANDLE hRandom, void* pBuffer, int nSize);
typedef BOOL (__stdcall *SBRandomGenerateProc)(HANDLE hRandom, void* pBuffer, int nSize);
typedef HANDLE (__stdcall *SBX509GetIssuerRDNProc)(HANDLE hCert);
typedef HANDLE (__stdcall *SBX509GetSubjectRDNProc)(HANDLE hCert);
typedef int	(__stdcall *SBX509SignDetachedProc)(HANDLE hCert, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize);
typedef int	(__stdcall *SBMessageSignerSignDetachedProc)(HANDLE hSigner, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize);
typedef int (__stdcall *SBMessageVerifierVerifyDetachedProc)(HANDLE hVerifier, void* pInBuffer, int nInSize, void* pSigBuffer, int nSigSize);
typedef BOOL (__stdcall *SBMessageVerifierIsSignatureDetachedProc)(void* pSigBuffer, int nSigSize);
typedef HANDLE (__stdcall *SBMessageVerifierGetCertIDProc)(HANDLE hVerifier, int nIndex);
typedef int (__stdcall *SBMessageVerifierGetCertIDCountProc)(HANDLE hVerifier);
typedef HANDLE (__stdcall *SBMessageVerifierGetAttributesProc)(HANDLE hVerifier);
typedef HANDLE (__stdcall *SBMessageSignerGetAuthenticatedAttributesProc)(HANDLE hSigner);
typedef HANDLE (__stdcall *SBMessageSignerGetUnauthenticatedAttributesProc)(HANDLE hSigner);
typedef HANDLE (__stdcall *SBPKCS7IssuerGetIssuerProc)(HANDLE hIssuer);
typedef BOOL (__stdcall *SBPKCS7IssuerGetSerialNumberProc)(HANDLE hIssuer, void* pBuffer, int* nSize);
typedef BOOL (__stdcall *SBPKCS7IssuerSetSerialNumberProc)(HANDLE hIssuer, void* pBuffer, int nSize);
typedef int (__stdcall *SBArrayListGetCountProc)(HANDLE hList) ;
typedef BOOL (__stdcall *SBArrayListGetValueProc)(HANDLE hList, int nIndex, void* pBuffer, int* nSize);
typedef BOOL (__stdcall *SBArrayListSetValueProc)(HANDLE hList, int nIndex, void* pBuffer, int nSize);
typedef int (__stdcall *SBArrayListAddProc)(HANDLE hList, void* pBuffer, int nSize);
typedef BOOL (__stdcall *SBArrayListRemoveProc)(HANDLE hList, int nIndex);
typedef BOOL (__stdcall *SBPKCS7AttributesRemoveProc)(HANDLE hAttrs, int nIndex);
typedef BOOL (__stdcall *SBPKCS7AttributesGetAttributeProc)(HANDLE hAttrs, int nIndex, void* pBuffer, int* nSize);
typedef BOOL (__stdcall *SBPKCS7AttributesSetAttributeProc)(HANDLE hAttrs, int nIndex, void* pBuffer, int nSize);
typedef HANDLE (__stdcall *SBPKCS7AttributesGetValuesProc)(HANDLE hAttrs, int nIndex);
typedef int (__stdcall *SBPKCS7AttributesGetCountProc)(HANDLE hAttrs);
typedef BOOL (__stdcall *SBPKCS7AttributesSetCountProc)(HANDLE hAttrs, int nCount);
typedef int (__stdcall *SBMessageDecryptorGetUsedCertificateProc)(HANDLE hDecryptor);
typedef HANDLE (__stdcall *SBMessageDecryptorGetCertIDProc)(HANDLE hDecryptor, int nIndex);
typedef int (__stdcall *SBMessageDecryptorGetCertIDCountProc)(HANDLE hDecryptor);
typedef BOOL (__stdcall *SBFormatAttributeValueProc)(int nTagID, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize);
typedef BOOL (__stdcall* SBUnformatAttributeValueProc)(void* pInBuffer, int nInSize, void* pOutBuffer,
							   int* nOutSize, int* nTagID);
typedef HANDLE	(__stdcall* SBCertificateRevocationListCreateProc)(void);
typedef BOOL (__stdcall* SBCertificateRevocationListDestroyProc)(HANDLE hCRL);
typedef BOOL (__stdcall* SBCertificateRevocationListAddProc)(HANDLE hCRL, HANDLE hCert);
typedef BOOL (__stdcall* SBCertificateRevocationListRemoveByIndexProc)(HANDLE hCRL, int nIndex);
typedef BOOL (__stdcall* SBCertificateRevocationListRemoveProc)(HANDLE hCRL, HANDLE hCert);
typedef BOOL (__stdcall* SBCertificateRevocationListIsPresentProc)(HANDLE hCRL, HANDLE hCert);
typedef int (__stdcall* SBCertificateRevocationListLoadFromBufferProc)(HANDLE hCRL, void* pBuffer, int nSize);
typedef int (__stdcall* SBCertificateRevocationListSaveToBufferProc)(HANDLE hCRL, void* pBuffer, int* nSize, HANDLE hCert);
typedef int (__stdcall* SBCertificateRevocationListValidateProc)(HANDLE hCRL, HANDLE hCert);
typedef HANDLE (__stdcall* SBCertificateRevocationListGetIssuerProc)(HANDLE hCRL);
typedef BOOL (__stdcall* SBCertificateRevocationListGetThisUpdateProc)(HANDLE hCRL, DATE* date);
typedef BOOL (__stdcall* SBCertificateRevocationListGetNextUpdateProc)(HANDLE hCRL, DATE* date);
typedef BOOL (__stdcall* SBCertificateRevocationListSetThisUpdateProc)(HANDLE hCRL, DATE date);
typedef BOOL (__stdcall* SBCertificateRevocationListSetNextUpdateProc)(HANDLE hCRL, DATE date);
typedef int (__stdcall* SBCertificateRevocationListGetSignatureAlgorithmProc)(HANDLE hCRL);
typedef HANDLE (__stdcall* SBCertificateRevocationListGetItemProc)(HANDLE hCRL, int nIndex);
typedef int (__stdcall* SBCertificateRevocationListGetCountProc)(HANDLE hCRL);
typedef BOOL (__stdcall* SBRevocationItemGetSerialNumberProc)(HANDLE hItem, void* pBuffer, int* nSize);
typedef BOOL (__stdcall* SBRevocationItemSetSerialNumberProc)(HANDLE hItem, void* pBuffer, int nSize);
typedef BOOL (__stdcall* SBRevocationItemGetRevocationDateProc)(HANDLE hItem, DATE* date);
typedef BOOL (__stdcall* SBRevocationItemSetRevocationDateProc)(HANDLE hItem, DATE date);
typedef BOOL (__stdcall* SetLicenseKeyProc)(PCHAR Key);

BOOL SBPKIInitialize(void)
{
	if (InterlockedExchange(&nDllRefs, nDllRefs) > 0)
	{
		InterlockedIncrement(&nDllRefs);
		return TRUE;
	}
	else
	{
		hDll = LoadLibrary(DLL_NAME);
		if (hDll == NULL)
			return FALSE;
		InterlockedIncrement(&nDllRefs);
		for (int i = 0; i < DLL_ROUTINE_COUNT; i++)
		{
			aDllRoutines[i] = GetProcAddress(hDll, aDllRoutineNames[i]);
		}
		return TRUE;
	}
}

void SBPKIFinalize(void)
{
	if (InterlockedExchange(&nDllRefs, nDllRefs) > 0)
	{
		if (InterlockedDecrement(&nDllRefs) == 0)
		{
			FreeLibrary(hDll);
			hDll = NULL;
		}
	}
}

BOOL	SBPKISetLicenseKey(PCHAR Key)
{
	if (hDll == NULL)
		return FALSE;
	else {
		((SetLicenseKeyProc)aDllRoutines[190])(Key);
		return TRUE;
	}
}

// X.509 Certificates interface

int		SBX509GetVersion(HANDLE hCert)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetVersionProc)aDllRoutines[0])(hCert);
}

BOOL	SBX509GetSerialNumber(HANDLE hCert, void* pSerialNumber, int* Size)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetSerialNumberProc)aDllRoutines[1])(hCert, pSerialNumber, Size);
}

HANDLE	SBX509Create(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509CreateProc)aDllRoutines[2])();
}

BOOL	SBX509LoadFromBuffer(HANDLE hCert, void* pData, int Size)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509LoadFromBufferProc)aDllRoutines[3])(hCert, pData, Size);
}

BOOL	SBX509GetCertificateBinary(HANDLE hCert, void* pBinaryData, int* Size)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetCertificateBinaryProc)aDllRoutines[4])(hCert, pBinaryData, Size);
}

BOOL	SBX509GetSignatureValue(HANDLE hCert, void* pSignature, int* Size)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetSignatureValueProc)aDllRoutines[5])(hCert, pSignature, Size);
}

BOOL	SBX509GetIssuer(HANDLE hCert, void* pIssuer, int* Size)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetIssuerProc)aDllRoutines[6])(hCert, pIssuer, Size);
}

BOOL	SBX509GetValidityFrom(HANDLE hCert, DATE *Date)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetValidityFromProc)aDllRoutines[7])(hCert, Date);
}

BOOL	SBX509GetValidityTo(HANDLE hCert, DATE *Date)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetValidityToProc)aDllRoutines[8])(hCert, Date);
}

BOOL	SBX509GetSubject(HANDLE hCert, void* pSubject, int* Size)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetSubjectProc)aDllRoutines[9])(hCert, pSubject, Size);
}

int		SBX509GetSignatureAlgorithm(HANDLE hCert)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetSignatureAlgorithmProc)aDllRoutines[10])(hCert);
}

int		SBX509GetPublicKeyAlgorithm(HANDLE hCert)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetPublicKeyAlgorithmProc)aDllRoutines[11])(hCert);
}

BOOL	SBX509GetRSAParams(HANDLE hCert, void* pRSAModulus, int* nRSAModulusSize,
			void* pRSAPublicExponent, int* nRSAPublicExponentSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetRSAParamsProc)aDllRoutines[12])(hCert, pRSAModulus, nRSAModulusSize,
			pRSAPublicExponent, nRSAPublicExponentSize);
}

BOOL	SBX509GetDSSSignatureParams(HANDLE hCert, void* pDSSS, int* nDSSSSize,
			void* pDSSR, int* nDSSRSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetDSSSignatureParamsProc)aDllRoutines[13])(hCert, pDSSS, nDSSSSize,
			pDSSR, nDSSRSize);
}

BOOL	SBX509GetDSSParams(HANDLE hCert, void* pDSSP, int* nDSSPSize, void* pDSSQ, int* nDSSQSize, 
			void* pDSSG, int* nDSSGSize, void* pDSSY, int* nDSSYSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509GetDSSParamsProc)aDllRoutines[14])(hCert, pDSSP, nDSSPSize,
			pDSSQ, nDSSQSize, pDSSG, nDSSGSize, pDSSY, nDSSYSize);
}

BOOL	SBX509GetDHParams(HANDLE hCert, void* pDHP, int* nDHPSize,
			void* pDHG, int* nDHGSize, void* pDHY, int* nDHYSize)
{
	if (hDll == NULL) 
		return NULL;
	else
		return ((SBX509GetDHParamsProc)aDllRoutines[15])(hCert, pDHP, nDHPSize, pDHG, nDHGSize, pDHY, nDHYSize);
}

BOOL	SBX509IsCertificateSelfSigned(HANDLE hCert)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509IsCertificateSelfSignedProc)aDllRoutines[16])(hCert);
}

BOOL	SBX509Validate(HANDLE hCert)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509ValidateProc)aDllRoutines[17])(hCert);
}

BOOL	SBX509ValidateRSA(HANDLE hCert, void* pRSAModulus, int nRSAModulusSize,
			void* pRSAPublicExponent, int nRSAPublicExponentSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509ValidateRSAProc)aDllRoutines[18])(hCert, pRSAModulus, nRSAModulusSize,
			pRSAPublicExponent, nRSAPublicExponentSize);
}

BOOL	SBX509ValidateDSS(HANDLE hCert, void* pDSSP, int nDSSPSize,
			void* pDSSQ, int nDSSQSize, void* pDSSG, int nDSSGSize,
			void* pDSSY, int nDSSYSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509ValidateDSSProc)aDllRoutines[19])(hCert, pDSSP, nDSSPSize,
			pDSSQ, nDSSQSize, pDSSG, nDSSGSize, pDSSY, nDSSYSize);
}

BOOL	SBX509ValidateWithCA(HANDLE hCert, void* pCACertificate, int nCACertificateSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509ValidateWithCAProc)aDllRoutines[20])(hCert, pCACertificate, nCACertificateSize);
}

BOOL	SBX509SetIssuer(HANDLE hCert, PCHAR Fields[])
{
	if (hDll == NULL) 
		return NULL;
	else
		return ((SBX509SetIssuerProc)aDllRoutines[21])(hCert, Fields);
}

BOOL	SBX509SetSubject(HANDLE hCert, PCHAR Fields[])
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBX509SetSubjectProc)aDllRoutines[22])(hCert, Fields);
}

BOOL	SBX509SaveToBuffer(HANDLE hCert, void* Buffer, int* nSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509SaveToBufferProc)aDllRoutines[23])(hCert, Buffer, nSize);
}

BOOL	SBX509SaveKeyToBuffer(HANDLE hCert, void* Buffer, int* nSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509SaveKeyToBufferProc)aDllRoutines[24])(hCert, Buffer, nSize);
}

BOOL	SBX509Generate(HANDLE hCert, int nAlgorithm, int nDwordsInEncryptKey)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509GenerateProc)aDllRoutines[25])(hCert, nAlgorithm, nDwordsInEncryptKey);
}

BOOL	SBX509CAGenerate(HANDLE hCert, int nAlgorithm, int nDwordsInEncryptKey)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509CAGenerateProc)aDllRoutines[26])(hCert, nAlgorithm, nDwordsInEncryptKey);
}

BOOL	SBX509SetCACertificate(HANDLE hCert, void* Buffer, int nSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509SetCACertificateProc)aDllRoutines[27])(hCert, Buffer, nSize);
}

BOOL	SBX509SetCAPrivateKey(HANDLE hCert, void* Buffer, int nSize)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509SetCAPrivateKeyProc)aDllRoutines[28])(hCert, Buffer, nSize);
}

BOOL	SBX509Destroy(HANDLE hCert)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509DestroyProc)aDllRoutines[29])(hCert);
}

BOOL	SBX509SetValidityFrom(HANDLE hCert, DATE Date)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509SetValidityFromProc)aDllRoutines[30])(hCert, Date);
}

BOOL	SBX509SetValidityTo(HANDLE hCert, DATE Date)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBX509SetValidityToProc)aDllRoutines[31])(hCert, Date);
}

BOOL	SBX509LoadKeyFromBuffer(HANDLE hCert, void* pBuffer, int nSize)
{
	if (hDll == NULL) 
		return NULL;
	else
		return((SBX509LoadKeyFromBufferProc)aDllRoutines[32])(hCert, pBuffer, nSize);
}

BOOL	SBX509LoadFromBufferPEM(HANDLE hCert, void* Buffer, int nSize, PCHAR PassPhrase)
{
	if (hDll == NULL) 
		return NULL;
	else
		return((SBX509LoadFromBufferPEMProc)aDllRoutines[33])(hCert, Buffer, nSize, PassPhrase);
}

BOOL	SBX509LoadKeyFromBufferPEM(HANDLE hCert, void* Buffer, int nSize, PCHAR PassPhrase)
{
	if (hDll == NULL) 
		return NULL;
	else
		return((SBX509LoadKeyFromBufferPEMProc)aDllRoutines[34])(hCert, Buffer, nSize, PassPhrase);
}

BOOL	SBX509SaveToBufferPEM(HANDLE hCert, void* Buffer, int* nSize, PCHAR PassPhrase)
{
	if (hDll == NULL) 
		return NULL;
	else
		return((SBX509SaveToBufferPEMProc)aDllRoutines[35])(hCert, Buffer, nSize, PassPhrase);
}

BOOL	SBX509SaveKeyToBufferPEM(HANDLE hCert, void* Buffer, int* nSize, PCHAR PassPhrase)
{
	if (hDll == NULL) 
		return NULL;
	else
		return((SBX509SaveKeyToBufferPEMProc)aDllRoutines[36])(hCert, Buffer, nSize, PassPhrase);
}

BOOL	SBX509Clone(HANDLE hCert, HANDLE hDestCert)
{
	if (hDll == NULL) 
		return FALSE;
	else
		return ((SBX509CloneProc)aDllRoutines[37])(hCert, hDestCert);
}

BOOL	SBX509GetHashMD5(HANDLE hCert, void* pBuffer)
{
	if (hDll == NULL) 
		return FALSE;
	else
		return ((SBX509GetHashMD5Proc)aDllRoutines[38])(hCert, pBuffer);
}

BOOL	SBX509GetHashSHA1(HANDLE hCert, void* pBuffer)
{
	if (hDll == NULL) 
		return FALSE;
	else
		return ((SBX509GetHashSHA1Proc)aDllRoutines[39])(hCert, pBuffer);
}

int		SBX509GetPublicKeySize(HANDLE hCert)
{
	if (hDll == NULL) 
		return FALSE;
	else
		return ((SBX509GetPublicKeySizeProc)aDllRoutines[40])(hCert);
}

BOOL	SBX509GetPublicKeyBlob(HANDLE hCert, void* pBuffer, int* nSize)
{
	if (hDll == NULL) 
		return FALSE;
	else
		return ((SBX509GetPublicKeyBlobProc)aDllRoutines[41])(hCert, pBuffer, nSize);
}

BOOL	SBX509PrivateKeyExists(HANDLE hCert)
{
	if (hDll == NULL) 
		return FALSE;
	else
		return ((SBX509PrivateKeyExistsProc)aDllRoutines[42])(hCert);
}

int		SBX509LoadFromBufferPFX(HANDLE hCert, void* pBuffer, int nSize, PCHAR Password)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBX509LoadFromBufferPFXProc)aDllRoutines[43])(hCert, pBuffer, nSize, Password);
}

int		SBX509SaveToBufferPFX(HANDLE hCert, void* pBuffer, int* nSize, PCHAR Password, int KeyEncryptionAlgorithm, int CertEncryptionAlgorithm)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBX509SaveToBufferPFXProc)aDllRoutines[44])(hCert, pBuffer, nSize, Password, 
			KeyEncryptionAlgorithm, CertEncryptionAlgorithm);
}

int		SBX509Sign(HANDLE hCert, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBX509SignProc)aDllRoutines[45])(hCert, pInBuffer, nInSize, pOutBuffer, nOutSize);
}

int		SBX509Verify(HANDLE hCert, void* pInBuffer, int nInSize, void* pSignature, int nSignatureSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBX509VerifyProc)aDllRoutines[46])(hCert, pInBuffer, nInSize, pSignature, nSignatureSize);
}

BOOL	SBX509GenerateByRequest(HANDLE hCert, HANDLE hRequest, HANDLE hNewCert)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBX509GenerateByRequestProc)aDllRoutines[47])(hCert, hRequest, hNewCert);
}

HANDLE	SBX509GetIssuerRDN(HANDLE hCert)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBX509GetIssuerRDNProc)aDllRoutines[48])(hCert);
}

HANDLE	SBX509GetSubjectRDN(HANDLE hCert)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBX509GetSubjectRDNProc)aDllRoutines[49])(hCert);
}

int		SBX509SignDetached(HANDLE hCert, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBX509SignDetachedProc)aDllRoutines[50])(hCert, pInBuffer, nInSize, pOutBuffer, nOutSize);
}

// Certificate storages interface

BOOL	SBGetAvailableSystemStores(char** pBuffer, int *nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBGetAvailableSystemStoresProc)aDllRoutines[51])(pBuffer, nSize);
}

BOOL	SBGetAvailablePhysicalStores(char* szSystemStore, char** pBuffer, int *nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBGetAvailablePhysicalStoresProc)aDllRoutines[52])(szSystemStore, pBuffer, nSize);
}

int		SBCertStorageFindByHashMD5(HANDLE hStorage, void* pHash)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertStorageFindByHashMD5Proc)aDllRoutines[53])(hStorage, pHash);
}

int		SBCertStorageFindByHashSHA1(HANDLE hStorage, void* pHash)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertStorageFindByHashSHA1Proc)aDllRoutines[54])(hStorage, pHash);
}

int		SBCertStorageGetIssuerCertificate(HANDLE hStorage, HANDLE hCert)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertStorageGetIssuerCertificateProc)aDllRoutines[55])(hStorage, hCert);
}

HANDLE	SBWinCertStorageCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageCreateProc)aDllRoutines[56])();
}

BOOL	SBWinCertStorageDestroy(HANDLE hStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageDestroyProc)aDllRoutines[57])(hStorage);
}

int		SBWinCertStorageValidate(HANDLE hStorage, HANDLE hCert,
  int* nReason)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBWinCertStorageValidateProc)aDllRoutines[58])(hStorage, hCert, nReason);
}

BOOL	SBWinCertStorageAdd(HANDLE hStorage, PCHAR StoreName)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageAddProc)aDllRoutines[59])(hStorage, StoreName);
}

BOOL	SBWinCertStorageRemove(HANDLE hStorage, PCHAR StoreName)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageRemoveProc)aDllRoutines[60])(hStorage, StoreName);
}

BOOL	SBWinCertStorageRemoveAll(HANDLE hStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageRemoveAllProc)aDllRoutines[61])(hStorage);
}

BOOL	SBWinCertStorageAddCertificate(HANDLE hStorage, HANDLE hCert)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageAddCertificateProc)aDllRoutines[62])(hStorage, hCert);
}

BOOL	SBWinCertStorageAddCertificateTo(HANDLE hStorage, HANDLE hCert, PCHAR StoreName)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageAddCertificateToProc)aDllRoutines[63])(hStorage, hCert, StoreName);
}

BOOL	SBWinCertStorageRemoveCertificate(HANDLE hStorage, int nIndex)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageRemoveCertificateProc)aDllRoutines[64])(hStorage, nIndex);
}

HANDLE	SBWinCertStorageGetCertificate(HANDLE hStorage, int nIndex)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageGetCertificateProc)aDllRoutines[65])(hStorage, nIndex);
}

int		SBWinCertStorageGetCount(HANDLE hStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageGetCountProc)aDllRoutines[66])(hStorage);
}

BOOL	SBWinCertStorageExportTo(HANDLE hStorage, HANDLE hExportToStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBWinCertStorageExportToProc)aDllRoutines[67])(hStorage, hExportToStorage);
}

HANDLE	SBFileCertStorageCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBFileCertStorageCreateProc)aDllRoutines[68])();
}

BOOL	SBFileCertStorageDestroy(HANDLE hStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBFileCertStorageDestroyProc)aDllRoutines[69])(hStorage);
}

int		SBFileCertStorageValidate(HANDLE hStorage, HANDLE hCert, 
  int* Reason)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBFileCertStorageValidateProc)aDllRoutines[70])(hStorage, hCert, Reason);
}

BOOL	SBFileCertStorageSetFilename(HANDLE hStorage, PCHAR Filename)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBFileCertStorageSetFilenameProc)aDllRoutines[71])(hStorage, Filename);
}

BOOL	SBFileCertStorageAdd(HANDLE hStorage, HANDLE hCert)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBFileCertStorageAddProc)aDllRoutines[72])(hStorage, hCert);
}

BOOL	SBFileCertStorageRemove(HANDLE hStorage, int nIndex)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBFileCertStorageRemoveProc)aDllRoutines[73])(hStorage, nIndex);
}

HANDLE	SBFileCertStorageGetCertificate(HANDLE hStorage, int nIndex)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBFileCertStorageGetCertificateProc)aDllRoutines[74])(hStorage, nIndex);
}

int		SBFileCertStorageGetCount(HANDLE hStorage)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBFileCertStorageGetCountProc)aDllRoutines[75])(hStorage);
}

BOOL	SBFileCertStorageSaveToFile(HANDLE hStorage, PCHAR Filename)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBFileCertStorageSaveToFileProc)aDllRoutines[76])(hStorage, Filename);
}

BOOL	SBFileCertStorageExportTo(HANDLE hStorage, HANDLE hExportToStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBFileCertStorageExportToProc)aDllRoutines[77])(hStorage, hExportToStorage);
}

HANDLE	SBMemoryCertStorageCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBMemoryCertStorageCreateProc)aDllRoutines[78])();
}

BOOL	SBMemoryCertStorageDestroy(HANDLE hStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBMemoryCertStorageDestroyProc)aDllRoutines[79])(hStorage);
}

int		SBMemoryCertStorageValidate(HANDLE hStorage, HANDLE hCert, int* Reason)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBMemoryCertStorageValidateProc)aDllRoutines[80])(hStorage, hCert, Reason);
}

BOOL	SBMemoryCertStorageAdd(HANDLE hStorage, HANDLE hCert)
{
	if (hDll == NULL)
		return NULL;
	else
		return((SBMemoryCertStorageAddProc)aDllRoutines[81])(hStorage, hCert);
}

BOOL	SBMemoryCertStorageRemove(HANDLE hStorage, int nIndex)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMemoryCertStorageRemoveProc)aDllRoutines[82])(hStorage, nIndex);
}

HANDLE	SBMemoryCertStorageGetCertificate(HANDLE hStorage, int nIndex)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMemoryCertStorageGetCertificateProc)aDllRoutines[83])(hStorage, nIndex);
}

int		SBMemoryCertStorageGetCount(HANDLE hStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMemoryCertStorageGetCountProc)aDllRoutines[84])(hStorage);
}

BOOL	SBMemoryCertStorageExportTo(HANDLE hStorage, HANDLE hExportToStorage)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMemoryCertStorageExportToProc)aDllRoutines[85])(hStorage, hExportToStorage);
}

// Relative distinguished name interface

HANDLE	SBRelativeDistinguishedNameCreate(void)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRelativeDistinguishedNameCreateProc)aDllRoutines[86])();
}

BOOL	SBRelativeDistinguishedNameDestroy(HANDLE hName)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRelativeDistinguishedNameDestroyProc)aDllRoutines[87])(hName);
}

BOOL	SBRelativeDistinguishedNameSetCount(HANDLE hName, int Count)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRelativeDistinguishedNameSetCountProc)aDllRoutines[88])(hName, Count);
}

int		SBRelativeDistinguishedNameGetCount(HANDLE hName)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBRelativeDistinguishedNameGetCountProc)aDllRoutines[89])(hName);
}

BOOL	SBRelativeDistinguishedNameSetOID(HANDLE hName, int Index, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRelativeDistinguishedNameSetOIDProc)aDllRoutines[90])(hName, Index, pBuffer, nSize);
}

BOOL	SBRelativeDistinguishedNameGetOID(HANDLE hName, int Index, void* pBuffer, int* nSize)
{
	if (hDll == NULL)
		return false;
	else 
		return ((SBRelativeDistinguishedNameGetOIDProc)aDllRoutines[91])(hName, Index, pBuffer, nSize);
}

BOOL	SBRelativeDistinguishedNameSetValue(HANDLE hName, int Index, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRelativeDistinguishedNameSetValueProc)aDllRoutines[92])(hName, Index, pBuffer, nSize);
}

BOOL	SBRelativeDistinguishedNameGetValue(HANDLE hName, int Index, void* pBuffer, int* nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRelativeDistinguishedNameGetValueProc)aDllRoutines[93])(hName, Index, pBuffer, nSize);
}

BOOL	SBRelativeDistinguishedNameRemove(HANDLE hName, int Index)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRelativeDistinguishedNameRemoveProc)aDllRoutines[94])(hName, Index);
}

// Certificate Request interface

HANDLE	SBCertificateRequestCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBCertificateRequestCreateProc)aDllRoutines[95])();
}

BOOL	SBCertificateRequestDestroy(HANDLE hRequest)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertificateRequestDestroyProc)aDllRoutines[96])(hRequest);
}

BOOL	SBCertificateRequestLoadFromBuffer(HANDLE hRequest, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertificateRequestLoadFromBufferProc)aDllRoutines[97])(hRequest, pBuffer, nSize);
}

BOOL	SBCertificateRequestGenerate(HANDLE hRequest, int PublicKeyAlgorithm, int Bits, int SignatureAlgorithm)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertificateRequestGenerateProc)aDllRoutines[98])(hRequest, PublicKeyAlgorithm, Bits, SignatureAlgorithm);
}

BOOL	SBCertificateRequestSaveToBuffer(HANDLE hRequest, void* pBuffer, int* nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertificateRequestSaveToBufferProc)aDllRoutines[99])(hRequest, pBuffer, nSize);
}

BOOL	SBCertificateRequestValidateSignature(HANDLE hRequest)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertificateRequestValidateSignatureProc)aDllRoutines[100])(hRequest);
}

BOOL	SBCertificateRequestGetRSAParams(HANDLE hRequest, void* pPublicModulus, int* nPublicModulusSize, void* pPublicExponent, int* nPublicExponentSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertificateRequestGetRSAParamsProc)aDllRoutines[101])(hRequest, pPublicModulus, nPublicModulusSize, pPublicExponent, nPublicExponentSize);
}

BOOL	SBCertificateRequestGetDSAParams(HANDLE hRequest, void* pP, int* nPSize, void* pQ, int* nQSize, void* pG, int* nGSize, void* pY, int* nYSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertificateRequestGetDSAParamsProc)aDllRoutines[102])(hRequest, pP, nPSize, pQ, nQSize, pG, nGSize, pY, nYSize);
}

BOOL	SBCertificateRequestGetPrivateKey(HANDLE hRequest, void* pBuffer, int* nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBCertificateRequestGetPrivateKeyProc)aDllRoutines[103])(hRequest, pBuffer, nSize);
}

HANDLE	SBCertificateRequestGetSubject(HANDLE hRequest)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBCertificateRequestGetSubjectProc)aDllRoutines[104])(hRequest);
}

HANDLE	SBCertificateRequestGetAttributes(HANDLE hRequest)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBCertificateRequestGetAttributesProc)aDllRoutines[105])(hRequest);
}

int		SBCertificateRequestGetPublicKeyAlgorithm(HANDLE hRequest)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBCertificateRequestGetPublicKeyAlgorithmProc)aDllRoutines[106])(hRequest);
}

int		SBCertificateRequestGetSignatureAlgorithm(HANDLE hRequest)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBCertificateRequestGetSignatureAlgorithmProc)aDllRoutines[107])(hRequest);
}

// Message Encryptor interface

HANDLE	SBMessageEncryptorCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMessageEncryptorCreateProc)aDllRoutines[108])();
}

BOOL	SBMessageEncryptorDestroy(HANDLE hEncryptor)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageEncryptorDestroyProc)aDllRoutines[109])(hEncryptor);
}

BOOL	SBMessageEncryptorSetCertStorage(HANDLE hEncryptor, HANDLE hStorage)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageEncryptorSetCertStorageProc)aDllRoutines[110])(hEncryptor, hStorage);
}

HANDLE	SBMessageEncryptorGetCertStorage(HANDLE hEncryptor)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMessageEncryptorGetCertStorageProc)aDllRoutines[111])(hEncryptor);
}

BOOL	SBMessageEncryptorSetAlgorithm(HANDLE hEncryptor, int Algorithm)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageEncryptorSetAlgorithmProc)aDllRoutines[112])(hEncryptor, Algorithm);
}

int		SBMessageEncryptorGetAlgorithm(HANDLE hEncryptor)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageEncryptorGetAlgorithmProc)aDllRoutines[113])(hEncryptor);
}

BOOL	SBMessageEncryptorSetBitsInKey(HANDLE hEncryptor, int Bits)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageEncryptorSetBitsInKeyProc)aDllRoutines[114])(hEncryptor, Bits);
}

int		SBMessageEncryptorGetBitsInKey(HANDLE hEncryptor)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageEncryptorGetBitsInKeyProc)aDllRoutines[115])(hEncryptor);
}

int		SBMessageEncryptorEncrypt(HANDLE hEncryptor, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageEncryptorEncryptProc)aDllRoutines[116])(hEncryptor, pInBuffer, nInSize, pOutBuffer, nOutSize);
}

// Message Decryptor interface

HANDLE	SBMessageDecryptorCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMessageDecryptorCreateProc)aDllRoutines[117])();
}

BOOL	SBMessageDecryptorDestroy(HANDLE hDecryptor)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageDecryptorDestroyProc)aDllRoutines[118])(hDecryptor);
}

BOOL	SBMessageDecryptorSetCertStorage(HANDLE hDecryptor, HANDLE hStorage)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageDecryptorSetCertStorageProc)aDllRoutines[119])(hDecryptor, hStorage);
}

HANDLE	SBMessageDecryptorGetCertStorage(HANDLE hDecryptor)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMessageDecryptorGetCertStorageProc)aDllRoutines[120])(hDecryptor);
}

int		SBMessageDecryptorGetAlgorithm(HANDLE hDecryptor)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageDecryptorGetAlgorithmProc)aDllRoutines[121])(hDecryptor);
}

int		SBMessageDecryptorGetBitsInKey(HANDLE hDecryptor)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageDecryptorGetBitsInKeyProc)aDllRoutines[122])(hDecryptor);
}

int		SBMessageDecryptorDecrypt(HANDLE hDecryptor, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageDecryptorDecryptProc)aDllRoutines[123])(hDecryptor, pInBuffer, nInSize, pOutBuffer, nOutSize);
}

int		SBMessageDecryptorGetUsedCertificate(HANDLE hDecryptor)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageDecryptorGetUsedCertificateProc)aDllRoutines[124])(hDecryptor);
}

HANDLE	SBMessageDecryptorGetCertID(HANDLE hDecryptor, int nIndex)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBMessageDecryptorGetCertIDProc)aDllRoutines[125])(hDecryptor, nIndex);
}

int		SBMessageDecryptorGetCertIDCount(HANDLE hDecryptor)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBMessageDecryptorGetCertIDCountProc)aDllRoutines[126])(hDecryptor);
}

// Message Signer interface

HANDLE	SBMessageSignerCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMessageSignerCreateProc)aDllRoutines[127])();
}

BOOL	SBMessageSignerDestroy(HANDLE hSigner)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageSignerDestroyProc)aDllRoutines[128])(hSigner);
}

BOOL	SBMessageSignerSetHashAlgorithm(HANDLE hSigner, int Algorithm)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageSignerSetHashAlgorithmProc)aDllRoutines[129])(hSigner, Algorithm);
}

int		SBMessageSignerGetHashAlgorithm(HANDLE hSigner)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageSignerGetHashAlgorithmProc)aDllRoutines[130])(hSigner);
}

BOOL	SBMessageSignerSetCertStorage(HANDLE hSigner, HANDLE hStorage)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageSignerSetCertStorageProc)aDllRoutines[131])(hSigner, hStorage);
}

HANDLE	SBMessageSignerGetCertStorage(HANDLE hSigner)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMessageSignerGetCertStorageProc)aDllRoutines[132])(hSigner);
}

int		SBMessageSignerSign(HANDLE hSigner, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageSignerSignProc)aDllRoutines[133])(hSigner, pInBuffer, nInSize, pOutBuffer, nOutSize);
}

int		SBMessageSignerSignDetached(HANDLE hSigner, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageSignerSignDetachedProc)aDllRoutines[134])(hSigner, pInBuffer, nInSize, pOutBuffer, nOutSize);
}

HANDLE	SBMessageSignerGetAuthenticatedAttributes(HANDLE hSigner)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBMessageSignerGetAuthenticatedAttributesProc)aDllRoutines[135])(hSigner);
}

HANDLE	SBMessageSignerGetUnauthenticatedAttributes(HANDLE hSigner)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBMessageSignerGetUnauthenticatedAttributesProc)aDllRoutines[136])(hSigner);
}

// Message Verifier interface

HANDLE	SBMessageVerifierCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMessageVerifierCreateProc)aDllRoutines[137])();
}

BOOL	SBMessageVerifierDestroy(HANDLE hVerifier)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageVerifierDestroyProc)aDllRoutines[138])(hVerifier);
}

BOOL	SBMessageVerifierSetCertStorage(HANDLE hVerifier, HANDLE hStorage)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageVerifierSetCertStorageProc)aDllRoutines[139])(hVerifier, hStorage);
}

HANDLE	SBMessageVerifierGetCertStorage(HANDLE hVerifier)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageVerifierGetCertStorageProc)aDllRoutines[140])(hVerifier);
}

int		SBMessageVerifierGetHashAlgorithm(HANDLE hVerifier)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageVerifierGetHashAlgorithmProc)aDllRoutines[141])(hVerifier);
}

HANDLE	SBMessageVerifierGetCertificates(HANDLE hVerifier)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBMessageVerifierGetCertificatesProc)aDllRoutines[142])(hVerifier);
}

int		SBMessageVerifierVerify(HANDLE hVerifier, void* pInBuffer, int nInSize, void* pOutBuffer, int* nOutSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageVerifierVerifyProc)aDllRoutines[143])(hVerifier, pInBuffer, nInSize, pOutBuffer, nOutSize);
}

int		SBMessageVerifierVerifyDetached(HANDLE hVerifier, void* pInBuffer, int nInSize, void* pSigBuffer, int nSigSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBMessageVerifierVerifyDetachedProc)aDllRoutines[144])(hVerifier, pInBuffer, nInSize, pSigBuffer, nSigSize);
}

BOOL	SBMessageVerifierIsSignatureDetached(void* pSigBuffer, int nSigSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBMessageVerifierIsSignatureDetachedProc)aDllRoutines[145])(pSigBuffer, nSigSize);
}

HANDLE	SBMessageVerifierGetCertID(HANDLE hVerifier, int nIndex)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBMessageVerifierGetCertIDProc)aDllRoutines[146])(hVerifier, nIndex);
}

int		SBMessageVerifierGetCertIDCount(HANDLE hVerifier)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBMessageVerifierGetCertIDCountProc)aDllRoutines[147])(hVerifier);
}

HANDLE	SBMessageVerifierGetAttributes(HANDLE hVerifier)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBMessageVerifierGetAttributesProc)aDllRoutines[148])(hVerifier);
}

// Random interface

HANDLE	SBRandomCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBRandomCreateProc)aDllRoutines[149])();
}

BOOL	SBRandomDestroy(HANDLE hRandom)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRandomDestroyProc)aDllRoutines[150])(hRandom);
}

BOOL	SBRandomRandomize(HANDLE hRandom, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRandomRandomizeProc)aDllRoutines[151])(hRandom, pBuffer, nSize);
}

BOOL	SBRandomGenerate(HANDLE hRandom, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBRandomGenerateProc)aDllRoutines[152])(hRandom, pBuffer, nSize);
}

// PKCS#7 issuer interface

HANDLE	SBPKCS7IssuerGetIssuer(HANDLE hIssuer)
{
	if (hDll == NULL) 
		return 0;
	else
		return ((SBPKCS7IssuerGetIssuerProc)aDllRoutines[153])(hIssuer);
}

BOOL	SBPKCS7IssuerGetSerialNumber(HANDLE hIssuer, void* pBuffer, int* nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBPKCS7IssuerGetSerialNumberProc)aDllRoutines[154])(hIssuer, pBuffer, nSize);
}

BOOL	SBPKCS7IssuerSetSerialNumber(HANDLE hIssuer, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBPKCS7IssuerSetSerialNumberProc)aDllRoutines[155])(hIssuer, pBuffer, nSize);
}

// Array List interface

int		SBArrayListGetCount(HANDLE hList) 
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBArrayListGetCountProc)aDllRoutines[156])(hList);
}

BOOL	SBArrayListGetValue(HANDLE hList, int nIndex, void* pBuffer, int* nSize)
{
	if (hDll == NULL) 
		return false;
	else
		return ((SBArrayListGetValueProc)aDllRoutines[157])(hList, nIndex, pBuffer, nSize);
}

BOOL	SBArrayListSetValue(HANDLE hList, int nIndex, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBArrayListSetValueProc)aDllRoutines[158])(hList, nIndex, pBuffer, nSize);
}

int		SBArrayListAdd(HANDLE hList, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBArrayListAddProc)aDllRoutines[159])(hList, pBuffer, nSize);
}

BOOL	SBArrayListRemove(HANDLE hList, int nIndex)
{
	if (hDll == NULL) 
		return false;
	else
		return ((SBArrayListRemoveProc)aDllRoutines[160])(hList, nIndex);
}

// PKCS#7 attributes interface

BOOL	SBPKCS7AttributesRemove(HANDLE hAttrs, int nIndex)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBPKCS7AttributesRemoveProc)aDllRoutines[161])(hAttrs, nIndex);
}

BOOL	SBPKCS7AttributesGetAttribute(HANDLE hAttrs, int nIndex, void* pBuffer, int* nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBPKCS7AttributesGetAttributeProc)aDllRoutines[162])(hAttrs, nIndex, pBuffer, nSize);
}

BOOL	SBPKCS7AttributesSetAttribute(HANDLE hAttrs, int nIndex, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBPKCS7AttributesSetAttributeProc)aDllRoutines[163])(hAttrs, nIndex, pBuffer, nSize);
}

HANDLE	SBPKCS7AttributesGetValues(HANDLE hAttrs, int nIndex)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBPKCS7AttributesGetValuesProc)aDllRoutines[164])(hAttrs, nIndex);
}

int		SBPKCS7AttributesGetCount(HANDLE hAttrs)
{
	if (hDll == NULL)
		return 0;
	else
		return ((SBPKCS7AttributesGetCountProc)aDllRoutines[165])(hAttrs);
}

BOOL	SBPKCS7AttributesSetCount(HANDLE hAttrs, int nCount)
{
	if (hDll == NULL)
		return false;
	else
		return ((SBPKCS7AttributesSetCountProc)aDllRoutines[166])(hAttrs, nCount);
}

BOOL	SBFormatAttributeValue(int nTagID, void* pInBuffer, int nInSize, void* pOutBuffer,
							   int* nOutSize)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBFormatAttributeValueProc)aDllRoutines[167])(nTagID, pInBuffer, nInSize, 
			pOutBuffer, nOutSize);
}

BOOL	SBUnformatAttributeValue(void* pInBuffer, int nInSize, void* pOutBuffer,
							   int* nOutSize, int* nTagID)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBUnformatAttributeValueProc)aDllRoutines[168])(pInBuffer, nInSize, pOutBuffer,
			nOutSize, nTagID);
}

// Certificate revocation lists interface

HANDLE	SBCertificateRevocationListCreate(void)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBCertificateRevocationListCreateProc)aDllRoutines[169])();
}

BOOL	SBCertificateRevocationListDestroy(HANDLE hCRL)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBCertificateRevocationListDestroyProc)aDllRoutines[170])(hCRL);
}

BOOL	SBCertificateRevocationListAdd(HANDLE hCRL, HANDLE hCert)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBCertificateRevocationListAddProc)aDllRoutines[171])(hCRL, hCert);
}

BOOL	SBCertificateRevocationListRemoveByIndex(HANDLE hCRL, int nIndex)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBCertificateRevocationListRemoveByIndexProc)aDllRoutines[172])(hCRL, nIndex);
}

BOOL	SBCertificateRevocationListRemove(HANDLE hCRL, HANDLE hCert)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBCertificateRevocationListRemoveProc)aDllRoutines[173])(hCRL, hCert);
}

BOOL	SBCertificateRevocationListIsPresent(HANDLE hCRL, HANDLE hCert)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBCertificateRevocationListIsPresentProc)aDllRoutines[174])(hCRL, hCert);
}

int		SBCertificateRevocationListLoadFromBuffer(HANDLE hCRL, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBCertificateRevocationListLoadFromBufferProc)aDllRoutines[175])(hCRL, pBuffer, nSize);
}

int		SBCertificateRevocationListSaveToBuffer(HANDLE hCRL, void* pBuffer, int* nSize, HANDLE hCert)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBCertificateRevocationListSaveToBufferProc)aDllRoutines[176])(hCRL, pBuffer, nSize, hCert);
}

int		SBCertificateRevocationListValidate(HANDLE hCRL, HANDLE hCert)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBCertificateRevocationListValidateProc)aDllRoutines[177])(hCRL, hCert);
}

HANDLE	SBCertificateRevocationListGetIssuer(HANDLE hCRL)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBCertificateRevocationListGetIssuerProc)aDllRoutines[178])(hCRL);
}

BOOL	SBCertificateRevocationListGetThisUpdate(HANDLE hCRL, DATE* date)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBCertificateRevocationListGetThisUpdateProc)aDllRoutines[179])(hCRL, date);
}

BOOL	SBCertificateRevocationListGetNextUpdate(HANDLE hCRL, DATE* date)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBCertificateRevocationListGetNextUpdateProc)aDllRoutines[180])(hCRL, date);
}

BOOL	SBCertificateRevocationListSetThisUpdate(HANDLE hCRL, DATE date)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBCertificateRevocationListSetThisUpdateProc)aDllRoutines[181])(hCRL, date);
}

BOOL	SBCertificateRevocationListSetNextUpdate(HANDLE hCRL, DATE date)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBCertificateRevocationListSetNextUpdateProc)aDllRoutines[182])(hCRL, date);
}

int		SBCertificateRevocationListGetSignatureAlgorithm(HANDLE hCRL)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBCertificateRevocationListGetSignatureAlgorithmProc)aDllRoutines[183])(hCRL);
}

HANDLE	SBCertificateRevocationListGetItem(HANDLE hCRL, int nIndex)
{
	if (hDll == NULL)
		return NULL;
	else
		return ((SBCertificateRevocationListGetItemProc)aDllRoutines[184])(hCRL, nIndex);
}

int		SBCertificateRevocationListGetCount(HANDLE hCRL)
{
	if (hDll == NULL)
		return -1;
	else
		return ((SBCertificateRevocationListGetCountProc)aDllRoutines[185])(hCRL);
}

BOOL	SBRevocationItemGetSerialNumber(HANDLE hItem, void* pBuffer, int* nSize)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBRevocationItemGetSerialNumberProc)aDllRoutines[186])(hItem, pBuffer, nSize);
}

BOOL	SBRevocationItemSetSerialNumber(HANDLE hItem, void* pBuffer, int nSize)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBRevocationItemSetSerialNumberProc)aDllRoutines[187])(hItem, pBuffer, nSize);
}

BOOL	SBRevocationItemGetRevocationDate(HANDLE hItem, DATE* date)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBRevocationItemGetRevocationDateProc)aDllRoutines[188])(hItem, date);
}

BOOL	SBRevocationItemSetRevocationDate(HANDLE hItem, DATE date)
{
	if (hDll == NULL)
		return FALSE;
	else
		return ((SBRevocationItemSetRevocationDateProc)aDllRoutines[189])(hItem, date);
}

