VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form frmCertInfo 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Certificate information"
   ClientHeight    =   3270
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6870
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   218
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   458
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton btnDecline 
      Cancel          =   -1  'True
      Caption         =   "Decline"
      Height          =   375
      Left            =   3480
      TabIndex        =   2
      Top             =   2760
      Width           =   1335
   End
   Begin VB.CommandButton btnAccept 
      Caption         =   "Accept"
      Default         =   -1  'True
      Height          =   375
      Left            =   2040
      TabIndex        =   1
      Top             =   2760
      UseMaskColor    =   -1  'True
      Width           =   1335
   End
   Begin ComctlLib.ListView lvCertInfo 
      Height          =   2535
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6615
      _ExtentX        =   11668
      _ExtentY        =   4471
      View            =   3
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   2
      BeginProperty ColumnHeader(1) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Property"
         Object.Width           =   2540
      EndProperty
      BeginProperty ColumnHeader(2) {0713E8C7-850A-101B-AFC0-4210102A8DA7} 
         SubItemIndex    =   1
         Key             =   ""
         Object.Tag             =   ""
         Text            =   "Value"
         Object.Width           =   7937
      EndProperty
   End
End
Attribute VB_Name = "frmCertInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public Accepted As Boolean

Private SB_CERT_OID_COMMON_NAME As String
Private SB_CERT_OID_SURNAME As String
Private SB_CERT_OID_COUNTRY As String
Private SB_CERT_OID_LOCALITY As String
Private SB_CERT_OID_STATE_OR_PROVINCE As String
Private SB_CERT_OID_ORGANIZATION As String
Private SB_CERT_OID_ORGANIZATION_UNIT As String
Private SB_CERT_OID_TITLE As String
Private SB_CERT_OID_NAME As String
Private SB_CERT_OID_GIVEN_NAME As String
Private SB_CERT_OID_INITIALS As String
Private SB_CERT_OID_GENERATION_QUALIFIER As String
Private SB_CERT_OID_DN_QUALIFIER As String

Private Function ConvertOIDToString(ByVal oid As String) As String
    Select Case oid
        Case SB_CERT_OID_COMMON_NAME
            Result = Result + "CN"
        Case SB_CERT_OID_SURNAME
            Result = Result + "SN"
        Case SB_CERT_OID_COUNTRY
            Result = Result + "C"
        Case SB_CERT_OID_LOCALITY
            Result = Result + "L"
        Case SB_CERT_OID_STATE_OR_PROVINCE
            Result = Result + "SP"
        Case SB_CERT_OID_ORGANIZATION
            Result = Result + "O"
        Case SB_CERT_OID_ORGANIZATION_UNIT
            Result = Result + "OU"
        Case SB_CERT_OID_TITLE
            Result = Result + "T"
        Case SB_CERT_OID_NAME
            Result = Result + "N"
        Case SB_CERT_OID_GIVEN_NAME
            Result = Result + "GN"
        Case SB_CERT_OID_INITIALS
            Result = Result + "I"
        Case SB_CERT_OID_GENERATION_QUALIFIER
            Result = Result + "GQ"
        Case SB_CERT_OID_DN_QUALIFIER
            Result = Result + "DNQ"
        Case Else
            Result = Result + "UNK"
    End Select
    ConvertOIDToString = Result
End Function

Private Function ConvertRDNToString(ByVal rdn As IElRelativeDistinguishedNameX) As String
Dim i As Integer
Dim oid As String, value As String, res As String
    res = ""
    For i = 0 To rdn.Count - 1
        oid = ConvertOIDToString(rdn.GetOID(i))
        value = rdn.GetValue(i)
        res = res & oid & "=" & value & ":"
    Next
    ConvertRDNToString = res
End Function

Private Sub MakeHexStringFromArray(ByVal Buf As Variant, ByRef Result As String)
    Dim i As Integer
    Result = ""
    If VarType(Buf) <> vbArray + vbByte Then
        Exit Sub
    End If
    For i = 0 To LenB(Buf) - 1
        Result = Result + Hex(Buf(i)) + ":"
    Next
End Sub

Private Function ConvertPublicKeyAlgorithmToString(ByVal alg As Integer) As String
    Select Case oid
        Case PKIBBox.SB_CERT_ALGORITHM_DH_PUBLIC
            Result = "DH public key"
        Case PKIBBox.SB_CERT_ALGORITHM_ID_DSA
            Result = "DSA"
        Case PKIBBox.SB_CERT_ALGORITHM_ID_DSA_SHA1
            Result = "sha1WithDSA"
        Case PKIBBox.SB_CERT_ALGORITHM_ID_RSA_ENCRYPTION
            Result = "RSA"
        Case PKIBBox.SB_CERT_ALGORITHM_MD2_RSA_ENCRYPTION
            Result = "md2WithRSA"
        Case PKIBBox.SB_CERT_ALGORITHM_MD5_RSA_ENCRYPTION
            Result = "md5WithRSA"
        Case PKIBBox.SB_CERT_ALGORITHM_SHA1_RSA_ENCRYPTION
            Result = "sha1WithRSA"
        Case Else
            Result = "Unknown"
    End Select
    ConvertPublicKeyAlgorithmToString = Result
End Function

Public Sub SetObject(ByVal cert As IElCertificateX5)
Dim item As ListItem
Dim S As String
    lvCertInfo.ListItems.Clear
    
    ' Version
    Set item = lvCertInfo.ListItems.Add
    item.Text = "Version"
    item.SubItems(1) = CStr(cert.Version + 1)
    
    ' Serial number
    Set item = lvCertInfo.ListItems.Add
    item.Text = "Serial Number"
    MakeHexStringFromArray cert.SerialNumber, S
    item.SubItems(1) = S
    
    ' Signature algorithm
    Set item = lvCertInfo.ListItems.Add
    item.Text = "Signature algorithm"
    S = ConvertPublicKeyAlgorithmToString(cert.SignatureAlgorithm)
    item.SubItems(1) = S
    
    ' Issuer
    Set item = lvCertInfo.ListItems.Add
    item.Text = "Issuer"
    item.SubItems(1) = ConvertRDNToString(cert.IssuerRDN)
    
    ' Validity period
    Set item = lvCertInfo.ListItems.Add
    item.Text = "Valid from"
    S = cert.ValidFrom
    item.SubItems(1) = S
    Set item = lvCertInfo.ListItems.Add
    item.Text = "Valid till"
    S = cert.ValidTo
    item.SubItems(1) = S
    
    ' Subject
    Set item = lvCertInfo.ListItems.Add
    item.Text = "Subject"
    item.SubItems(1) = ConvertRDNToString(cert.SubjectRDN)
    
    ' Public key algorithm
    Set item = lvCertInfo.ListItems.Add
    item.Text = "Public key"
    S = ConvertPublicKeyAlgorithmToString(cert.PublicKeyAlgorithm)
    item.SubItems(1) = S
End Sub

Private Sub btnAccept_Click()
    Accepted = True
    Hide
End Sub

Private Sub btnDecline_Click()
    Accepted = False
    Hide
End Sub

Private Sub Form_Load()
    Let SB_CERT_OID_COMMON_NAME = Chr(&H55) + Chr(&H4) + Chr(&H3)
    Let SB_CERT_OID_SURNAME = Chr(&H55) + Chr(&H4) + Chr(&H4)
    Let SB_CERT_OID_COUNTRY = Chr(&H55) + Chr(&H4) + Chr(&H6)
    Let SB_CERT_OID_LOCALITY = Chr(&H55) + Chr(&H4) + Chr(&H7)
    Let SB_CERT_OID_STATE_OR_PROVINCE = Chr(&H55) + Chr(&H4) + Chr(&H8)
    Let SB_CERT_OID_ORGANIZATION = Chr(&H55) + Chr(&H4) + Chr(&HA)
    Let SB_CERT_OID_ORGANIZATION_UNIT = Chr(&H55) + Chr(&H4) + Chr(&HB)
    Let SB_CERT_OID_TITLE = Chr(&H55) + Chr(&H4) + Chr(&HC)
    Let SB_CERT_OID_NAME = Chr(&H55) + Chr(&H4) + Chr(&H29)
    Let SB_CERT_OID_GIVEN_NAME = Chr(&H55) + Chr(&H4) + Chr(&H2A)
    Let SB_CERT_OID_INITIALS = Chr(&H55) + Chr(&H4) + Chr(&H2B)
    Let SB_CERT_OID_GENERATION_QUALIFIER = Chr(&H55) + Chr(&H4) + Chr(&H2C)
    Let SB_CERT_OID_DN_QUALIFIER = Chr(&H55) + Chr(&H4) + Chr(&H2E)
End Sub
