// CertInfoDlg.h : header file
//

#if !defined(AFX_CERTINFODLG_H__7F674802_5E98_4DA1_AD98_AF932D5117DC__INCLUDED_)
#define AFX_CERTINFODLG_H__7F674802_5E98_4DA1_AD98_AF932D5117DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CCertInfoDlg dialog

class CCertInfoDlg : public CDialog
{
// Construction
public:
	CCertInfoDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CCertInfoDlg)
	enum { IDD = IDD_CERTINFO_DIALOG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCertInfoDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	CImageList m_imglist;

	void InitializeTreeCtrl();
	void InitializeComboBox();
	void RefreshCertificateList();
	void ErrorInfo(LPCTSTR lpszErrorMsg);

	BOOL SaveCertDER(HANDLE hCert, LPCTSTR lpszFilename);
	BOOL SaveCertPEM(HANDLE hCert, LPCTSTR lpszFilename);
	BOOL SaveCertPFX(HANDLE hCert, LPCTSTR lpszFilename);
	BOOL LoadCertDER(HANDLE hCert, LPCTSTR lpszFilename);
	BOOL LoadCertPEM(HANDLE hCert, LPCTSTR lpszFilename);
	BOOL LoadCertPFX(HANDLE hCert, LPCTSTR lpszFilename);

	// Generated message map functions
	//{{AFX_MSG(CCertInfoDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeCombocs();
	afx_msg void OnButtonexport();
	afx_msg void OnButtonimport();
	afx_msg void OnButtonencrypt();
	afx_msg void OnButtondecrypt();
	afx_msg void OnButtonsign();
	afx_msg void OnButtonverify();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CERTINFODLG_H__7F674802_5E98_4DA1_AD98_AF932D5117DC__INCLUDED_)
